//+------------------------------------------------------------------+
//|                                               WPR in Squares.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern int    WPR_Period = 240;
extern double UpLevel = -20;
extern double DnLevel = -80;

extern color UpSquare = Blue;
extern color DnSquare = Red;

string objname = "mySquare";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
datetime time;
int init()
{
  time = Time[0];
  
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   DellObj(objname);
 return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   int bars;
   
   bars = Bars-1;
   if(counted_bars >= 0) bars = Bars-counted_bars-1;
   
   double max = High[0];
   double min = Low[0];
   double _wpr, wpr;
 
   datetime draw_to = Time[0]+86400;  
   //DrawSquare("lol", Time[10], Low[10], Time[1], High[1], UpSquare);
   //Comment(bars);
   
   for( int i = 1 ; i <= bars ; i++ )
   {      
     _wpr = iWPR(NULL, 0, WPR_Period, i+1);
      wpr = iWPR(NULL, 0, WPR_Period, i);
      
      if( _wpr <= -50.0 && wpr > -50.0 && Low[i]  < min ) DrawSquare(objname+"Up_-50_"+Time[i], Time[i], Low[i], draw_to, High[i], UpSquare);
      if( _wpr >= -50.0 && wpr < -50.0 && High[i] > max ) DrawSquare(objname+"Dn_-50_"+Time[i], Time[i], High[i], draw_to, Low[i], DnSquare);
    

      if( _wpr <= UpLevel && wpr > UpLevel && Low[i]  < min ) DrawSquare(objname+"Up_UpLevel_"+Time[i], Time[i], Low[i], draw_to, High[i], UpSquare);
      if( _wpr >= UpLevel && wpr < UpLevel && High[i] > max ) DrawSquare(objname+"Dn_UpLevel_"+Time[i], Time[i], High[i], draw_to, Low[i], DnSquare);


      if( _wpr <= DnLevel && wpr > DnLevel && Low[i]  < min ) DrawSquare(objname+"Up_DnLevel_"+Time[i], Time[i], Low[i], draw_to, High[i], UpSquare);
      if( _wpr >= DnLevel && wpr < DnLevel && High[i] > max ) DrawSquare(objname+"Dn_DnLevel_"+Time[i], Time[i], High[i], draw_to, Low[i], DnSquare);

      max = MathMax(max, High[i]);
      min = MathMin(min, Low[i]);
   }     
   
   if( bars == 1 ) 
      SquareRefreshLength(draw_to);
      
   SquareRemaximumDellfor();   
   
 return(0);
}
//+------------------------------------------------------------------+
//
void DellObj( string dell )
{
  string name;
   for(int i = ObjectsTotal()-1 ; i >=0 ; i-- ){
      name = ObjectName(i);
      if( StringFind(name, dell) != EMPTY )
         ObjectDelete(name);
   }
}
//+------------------------------------------------------------------+
//
void DrawSquare( string name, datetime time1, double price1, datetime time2, double price2, color col )
{
   if( !ObjectCreate(name, OBJ_RECTANGLE, 0, time1, price1, time2, price2) ) return; 
   ObjectSet(name, OBJPROP_COLOR, col );
}
//+------------------------------------------------------------------+
//
void SquareRefreshLength( datetime to )
{
  string name;
   for(int i = ObjectsTotal()-1 ; i >=0 ; i-- ){
      name = ObjectName(i);
      if( StringFind(name, objname) != EMPTY )
         ObjectSet(name, OBJPROP_TIME2, to);
   }
}
//+------------------------------------------------------------------+
//
void SquareRemaximumDellfor()
{
   string name;
   for(int i = ObjectsTotal()-1 ; i >=0 ; i-- ){
      name = ObjectName(i);
      if( StringFind(name, objname+"Up") != EMPTY )
         if( Close[0] <= ObjectGet(name, OBJPROP_PRICE1) )
            ObjectDelete(name);
            
      if( StringFind(name, objname+"Dn") != EMPTY )
         if( Close[0] >= ObjectGet(name, OBJPROP_PRICE1) )
         {
        //   Comment(ObjectGet(name, OBJPROP_PRICE1), "  Bid: ", Bid);
            ObjectDelete(name);        
             
         }
   }
}